From 3caa50ac99cb77fca136906299b5d1486cf26759 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 20 2020 04:38:44 +0000
Subject: [PATCH 299/2232] Share function link name mangling logic


---

diff --git a/gen/write.rs b/gen/write.rs
index 59e12ed..4df404c 100644
--- a/gen/write.rs
+++ b/gen/write.rs
@@ -2,7 +2,9 @@ use crate::gen::out::OutFile;
 use crate::gen::{include, Opt};
 use crate::syntax::atom::Atom::{self, *};
 use crate::syntax::namespace::Namespace;
-use crate::syntax::{Api, ExternFn, ExternType, Receiver, Signature, Struct, Type, Types, Var};
+use crate::syntax::{
+    mangle, Api, ExternFn, ExternType, Receiver, Signature, Struct, Type, Types, Var,
+};
 use proc_macro2::Ident;
 use std::collections::HashMap;
 
@@ -365,15 +367,8 @@ fn write_cxx_function_shim(out: &mut OutFile, efn: &ExternFn, types: &Types) {
     } else {
         write_extern_return_type_space(out, &efn.ret, types);
     }
-    let receiver_type = match &efn.receiver {
-        Some(base) => base.ident.to_string(),
-        None => "_".to_string(),
-    };
-    write!(
-        out,
-        "{}cxxbridge02${}${}(",
-        out.namespace, receiver_type, efn.ident
-    );
+    let mangled = mangle::extern_fn(&out.namespace, efn);
+    write!(out, "{}(", mangled);
     if let Some(base) = &efn.receiver {
         write!(out, "{} *self$", base.ident);
     }
@@ -519,14 +514,7 @@ fn write_function_pointer_trampoline(
 }
 
 fn write_rust_function_decl(out: &mut OutFile, efn: &ExternFn, types: &Types) {
-    let receiver_type = match &efn.receiver {
-        Some(base) => base.ident.to_string(),
-        None => "_".to_string(),
-    };
-    let link_name = format!(
-        "{}cxxbridge02${}${}",
-        out.namespace, receiver_type, efn.ident
-    );
+    let link_name = mangle::extern_fn(&out.namespace, efn);
     let indirect_call = false;
     write_rust_function_decl_impl(out, &link_name, efn, types, indirect_call);
 }
@@ -578,14 +566,7 @@ fn write_rust_function_shim(out: &mut OutFile, efn: &ExternFn, types: &Types) {
         writeln!(out, "//{}", line);
     }
     let local_name = efn.ident.to_string();
-    let receiver_type = match &efn.receiver {
-        Some(base) => base.ident.to_string(),
-        None => "_".to_string(),
-    };
-    let invoke = format!(
-        "{}cxxbridge02${}${}",
-        out.namespace, receiver_type, efn.ident
-    );
+    let invoke = mangle::extern_fn(&out.namespace, efn);
     let indirect_call = false;
     write_rust_function_shim_impl(out, &local_name, efn, types, &invoke, indirect_call);
 }
diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 373bfee..d8bd241 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -1,6 +1,8 @@
 use crate::syntax::atom::Atom::{self, *};
 use crate::syntax::namespace::Namespace;
-use crate::syntax::{self, check, Api, ExternFn, ExternType, Signature, Struct, Type, Types};
+use crate::syntax::{
+    self, check, mangle, Api, ExternFn, ExternType, Signature, Struct, Type, Types,
+};
 use proc_macro2::{Ident, Span, TokenStream};
 use quote::{format_ident, quote, quote_spanned};
 use syn::{parse_quote, Error, ItemMod, Result, Token};
@@ -154,11 +156,7 @@ fn expand_cxx_function_decl(namespace: &Namespace, efn: &ExternFn, types: &Types
         let ret = expand_extern_type(efn.ret.as_ref().unwrap());
         outparam = Some(quote!(__return: *mut #ret));
     }
-    let receiver_type = match &efn.receiver {
-        Some(base) => base.ident.to_string(),
-        None => "_".to_string(),
-    };
-    let link_name = format!("{}cxxbridge02${}${}", namespace, receiver_type, ident);
+    let link_name = mangle::extern_fn(namespace, efn);
     let local_name = format_ident!("__{}", ident);
     quote! {
         #[link_name = #link_name]
@@ -370,11 +368,7 @@ fn expand_rust_type(ety: &ExternType) -> TokenStream {
 
 fn expand_rust_function_shim(namespace: &Namespace, efn: &ExternFn, types: &Types) -> TokenStream {
     let ident = &efn.ident;
-    let receiver_type = match &efn.receiver {
-        Some(base) => base.ident.to_string(),
-        None => "_".to_string(),
-    };
-    let link_name = format!("{}cxxbridge02${}${}", namespace, receiver_type, ident);
+    let link_name = mangle::extern_fn(namespace, efn);
     let local_name = format_ident!("__{}", ident);
     let catch_unwind_label = format!("::{}", ident);
     let invoke = Some(ident);
diff --git a/syntax/mangle.rs b/syntax/mangle.rs
new file mode 100644
index 0000000..9e6bb8a
--- /dev/null
+++ b/syntax/mangle.rs
@@ -0,0 +1,10 @@
+use crate::syntax::namespace::Namespace;
+use crate::syntax::ExternFn;
+
+pub fn extern_fn(namespace: &Namespace, efn: &ExternFn) -> String {
+    let receiver_type = match &efn.receiver {
+        Some(receiver) => receiver.ident.to_string(),
+        None => "_".to_string(),
+    };
+    format!("{}cxxbridge02${}${}", namespace, receiver_type, efn.ident)
+}
diff --git a/syntax/mod.rs b/syntax/mod.rs
index 21ff447..b7ca6b7 100644
--- a/syntax/mod.rs
+++ b/syntax/mod.rs
@@ -7,6 +7,7 @@ mod doc;
 pub mod error;
 pub mod ident;
 mod impls;
+pub mod mangle;
 pub mod namespace;
 mod parse;
 pub mod set;

